<?php
/*
Plugin Name: FeedBurner Redirect

Plugin URI: http://082net.com/tag/feedburner-redirect/

Description: This plugin requires WP 2.0 or greater. Redirect pre-defined feed(entire,category,author,tag,comments) URL to FeedBurner URL. Based on <a href="http://www.orderedlist.com/">Steve Smith</a>'s <a href="http://www.orderedlist.com/articles/wordpress_feedburner_plugin/">Feedburner Feed Replacement</a> plugin. You should <strong>Uninstall</strong> other feedburner redirect plugins.

Version: 0.5

Author: Choen, Youngmin
Author URI: http://082net.com/
*//*
Change Logs ::

v0.4 : Removed .htaccess redirction
			Ready for WP 2.3


Lisense : GPL(http://www.gnu.org/copyleft/gpl.html)
/*  Copyright 2006  Cheon, Young-Min  (email : 082net@gmail.com, site : http://082net.com)
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class FeedBurner_Redirect {
	var $version = '0.5';
	var $rules;
	var $option;
	var $fb_url = "http://feeds.feedburner.com/";
	var $use_permalinks;
	var $home;

	function FeedBurner_Redirect() {
		load_plugin_textdomain('fb-redirect');
		$this->option = get_option('fb_redirect');
		$this->rules = get_option('fb_redirect_rules');
		$this->use_permalinks = false;//get_option('permalink_structure') != '';
		// upgrade options
		if($this->option['fb_path'])
			$this->upgrade_option();
//		$this->home = $this->get_web_path();
		$this->fb_url = trailingslashit($this->fb_url);
	}
/*
	function get_web_path($url='home') {
		$home_path = parse_url(get_option($url));
		if ( isset($home_path['path']) )
			$home_path = $home_path['path'];
		else
			$home_path = '';
		$home_path = trim($home_path, '/');
		return $home_path;
	}
*/
	function upgrade_option() {
		$this->option['fb_main'] = $this->option['fb_path'];
		unset($this->option['fb_path']);
		update_option('fb_redirect', $this->option);
		if(is_array($this->rules) && !empty($this->rules)) {
			foreach($this->rules as $type=>$rules) {
				foreach($rules as $key=>$rule) {
					$this->rules[$type][$key] = $this->option['fb_main'].'/'.$rule;
				}
			}
			update_option('fb_redirect_rules', $this->rules);
		}
	}

	function add_options() {
		if(!$this->option) {
			$this->option = array();
			$this->option['fb_main'] = 0;
			$this->option['active'] = 0;
			$this->option['success'] = 0;
			add_option('fb_redirect', $this->option);
		}
		if(!$this->rules) {
			add_option('fb_redirect_rules', 1);
		}
	}

	function add_options_page() {
		if (function_exists('add_options_page')) {
			add_options_page("FB Redirect", "FB Redirect", 8, 'feedburner-redirect', array(&$this, 'option_page'));
		}
	}

	function is_feedburner() {
		return preg_match("/feedburner|feedvalidator/i", $_SERVER['HTTP_USER_AGENT']);
	}

	function redirect($location) {
		global $is_IIS;
		if ( $is_IIS ) {
			header("Refresh: 0;url=$location");
		} else {
			if ( php_sapi_name() != 'cgi-fcgi' ) {
				if ( version_compare(phpversion(), '4.3.0', '>=') )
					@header("HTTP/1.1 307 Temporary Redirect", true, 307);
				else
					@header("HTTP/1.1 307 Temporary Redirect");		
			}
			header("Location: $location");
		}
		exit();
	}

	function direct_access() {
		$redirect = $this->fb_url;
		switch (basename($_SERVER['PHP_SELF'])) {
			case 'wp-rss.php':
			case 'wp-rss2.php':
			case 'wp-atom.php':
			case 'wp-rdf.php':
			if(!$this->option['fb_main'])
				return;
			$redirect .= $this->option['fb_main'].'/';
			$this->redirect($redirect);
			break;
			case 'wp-commentsrss2.php':
			if(!isset($this->rules['comments'][1]))
				return;
			$redirect .= $this->rules['comments'][1].'/';
			$this->redirect($redirect);
			break;
			default:
			break;
		}
	}

	function _redirect() {
		global $wp, $doing_rss, $withcomments;
		if ( (!is_feed() && !$doing_rss) || is_single() || is_page() || is_date() || is_search())
			return;
		$qv = $wp->query_vars;
		$feed = preg_replace('/^_+/', '', $qv['feed']);
		$redirect = $this->fb_url;
		// main feed
		if ($withcomments != 1 && $feed != 'comments-rss2' && !is_archive() && $qv['tag'] == '') {
			$redirect .= $this->option['fb_main'].'/';
			$this->redirect($redirect);
		}
		if(!is_array($this->rules) || empty($this->rules))
			return;
		if(($feed == 'comments-rss2' || $withcomments == 1) && isset($this->rules['comments'][1])) {
			$redirect .= $this->rules['comments'][1].'/';
			$this->redirect($redirect);
		}
		if (empty($qv['cat']) && empty($qv['author']) && empty($qv['tag']))
			return;
		$myset = array('cat', 'author', 'tag');
		foreach($myset as $key) {
			if(isset($qv[$key]) && isset($this->rules[$key][$qv[$key]])) {
				$redirect .= $this->rules[$key][$qv[$key]].'/';
				$this->redirect($redirect);
				break;
			}
		}
		return;
	}
/*
	function activate() {
		$this->add_options();
		if($this->option['fb_main'] && $this->option['active']) {
			$this->option['success'] = $this->apply_rules();
			update_option('fb_redirect', $this->option);
		}
	}

	function deactivate() {
		if($this->use_permalinks) {
			remove_filter('mod_rewrite_rules', array(&$this, 'Rewrite_redirect'));
			$remove = $this->apply_rules();
		}
	}
*/
	function get_categories() {
		if(function_exists('_make_cat_compat')) {// WP 2.3 or later
			$cats = get_categories();
			if(!$cats || !is_array($cats) || empty($cats))
				return false;
			$newcat = array();
			foreach(array_keys($cats) as $k) {
				$newcat[$k]->ID = $cats[$k]->cat_ID;
				$newcat[$k]->name = $cats[$k]->cat_name;
			}
			return $newcat;
		}
		global $wpdb;
		$cats = $wpdb->get_results("SELECT cat_ID AS ID, cat_name AS name FROM $wpdb->categories");
		return $cats;
	}

	function get_authors() {
		global $wpdb;
		$authors = $wpdb->get_results("SELECT ID, display_name AS name FROM $wpdb->users");
		return $authors;
	}

	function get_tags() {
		$plugin = $this->use_tag();
		$tags = array();
		switch($plugin){
			case 'core':
				$tagset = get_tags('orderby=name&order=ASC&number=0');
				foreach($tagset as $row) {
					$tags[] = $row->name;
				}
			break;
			case 'utw':
			global $utw;
			$tagset = $utw->GetPopularTags(-1, 'tag', 'asc');
			if(is_array($tagset)) {
				foreach( $tagset as $row )
					$tags[] = $row->tag;
			}
			break;
			case 'jkeywords_2':
			global $JKeywords;
			$tagset = $JKeywords->getAllTags();
			foreach($tagset as $tag)
				$tags[] = str_replace(' ', '+', $tag['name']);
			uksort($tags, 'strnatcasecmp');
			break;
			case 'jkeywords_1':
			$tagset = get_all_keywords();
			if(is_array($tagset)) {
				foreach($tagset as $tag=>$count)
					$tags[] = str_replace(' ', '+', $tag);
			}
			break;
			case 'stp':
				global $STagging;
			$tagset = $STagging->getAllTags(true, 0);
			ksort($tagset);
			foreach($tagset as $tag)
				$tags[] = $tag['name'];
			break;
		}
		return $tags;
	}

	function use_tag() {
		$tag_plugin = false;
		if(function_exists('wp_tag_cloud'))
			$tag_plugin = 'core';
		elseif(function_exists('UTW_ShowTagsForCurrentPost'))
			$tag_plugin = 'utw';
		elseif(class_exists('JeromesKeywords'))
			$tag_plugin = 'jkeywords_2';
		elseif(function_exists('get_all_keywords'))
			$tag_plugin = 'jkeywords_1';
		elseif(class_exists('SimpleTagging'))
			$tag_plugin = 'stp';
		return $tag_plugin;
	}

	function get_nicename($type, $key) {
		global $wpdb;
		switch($type) {
			case 'comments':
				$name = __('Entire comments on blog', 'fb-redirect');
			break;
			case 'cat':
				if(function_exists('get_cat_name'))// WP 2.3 or later
					$name = get_cat_name($key);
				else
					$name = $wpdb->get_var("SELECT cat_name AS name FROM $wpdb->categories WHERE cat_ID = $key LIMIT 1");
			break;
			case 'author':
				$name = $wpdb->get_var("SELECT display_name AS name FROM $wpdb->users WHERE ID = $key LIMIT 1");
			break;
			case 'tag':
				$name = str_replace(array('-', '_', '+'), ' ', $key);
			break;
		}
		return $name;
	}

	function add_rule() {
		$type = '';
		$v = $_POST['fb_add'];
		if(isset($_POST['fb_add_comments'])) {
			$type = 'comments';
		} elseif(isset($_POST['fb_add_cat'])) {
			$type = 'cat';
		} elseif(isset($_POST['fb_add_author'])) {
			$type = 'author';
		} elseif(isset($_POST['fb_add_tag'])) {
			$type = 'tag';
		}
		if(!$v[$type]['value'] || empty($v[$type]['path']))
			return __('Failed to Add New Rule. Please fill in or select all required fields.', 'fb-redirect');
		else {
			$key = trim($v[$type]['value']);
			if(!is_array($this->rules))
				$this->rules = array();
			$this->rules[$type][$key] = trim(trim($v[$type]['path']), '/');
			update_option('fb_redirect_rules', $this->rules);
			return __('New Rule Added.', 'fb-redirect');
		}
	}

	function delete_rules() {
		$v = $_POST['fb_delete'];
		if(!is_array($v) || empty($v))
			return __('Failed to Delete Rules. You should select more than one rule.', 'fb-redirect');
		foreach($v as $type=>$rules) {
			foreach($rules as $key=>$value) {
				unset($this->rules[$type][$key]);
			}
			if(empty($this->rules[$type]))
				unset($this->rules[$type]);
		}
		if(empty($this->rules))
			$this->rules = 1;
		update_option('fb_redirect_rules', $this->rules);
		return __('Rules Deleted.', 'fb-redirect');
	}

	function update_options() {
		$message = '';
		$_POST['fb_main'] = trim($_POST['fb_main']);
		if(isset($_POST['fb_update_options']) && !empty($_POST['fb_main']) && $_POST['fb_main'] !== '/') {
			$this->option['fb_main'] = trim($_POST['fb_main'], '/');
			if(isset($_POST['fb_active'])) {
				$this->option['active'] = (int) $_POST['fb_active'];
//				$this->option['htaccess'] = (int) $_POST['htaccess'];
			}
			update_option('fb_redirect', $this->option);
			$message = __('Options saved.');
		} elseif(isset($_POST['fb_add_rule'])) {
			$message = $this->add_rule();
		} elseif (isset($_POST['delete_checked'])) {
			$message = $this->delete_rules();
		}
		if('' !== $message)
			echo "\n".'<div id="message" class="updated fade"><p><strong>'. $message .'</strong></p></div>'."\n";
	}

	function option_page () {
		// update options
		$this->update_options();
		$active = $this->option['active'];
		$fb_main = $this->option['fb_main'];
//		$htaccess = $this->option['htaccess'];
?>
<div class="wrap">
<h2><?php _e('FeedBurner Redirect', 'fb-redirect'); ?> <?php echo $this->version; ?></h2>
	<form name="fbredirect_options" method="post" action="">
	<fieldset class="options">
	<legend><?php _e('General Options', 'fb-redirect'); ?></legend>
	<table cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th width="20%"><?php _e('Default FeedBurner Path', 'fb-redirect'); ?>:</th>
		<td><strong>http://feeds.feedburner.com/</strong><input type="text" name="fb_main" value="<?php if($fb_main) echo $fb_main; ?>" /> <br />
		&mdash; <?php _e('(No trailing slash)', 'fb-redirect'); ?></td>
	</tr>
<?php 
if(function_exists('add_feedburner_redirect') || function_exists('ol_feed_redirect')) {
	$this->option['active'] = 0;
	update_option('fb_redirect', $this->option);
?>
	<tr>
		<th width="20%"><?php _e('Note', 'fb-redirect'); ?>:</th>
		<td><?php _e('You should <strong>Uninstall</strong> other feedburner plugin first!.', 'fb-redirect'); ?></td>
	</tr>
<?php
} elseif(!$fb_main) {
?>
	<tr>
		<th width="20%"><?php _e('Note', 'fb-redirect'); ?>:</th>
		<td><?php _e('You should set default FeedBurner Path first!.', 'fb-redirect'); ?><br />
		<?php echo __('If you don\'t already have one', 'fb-redirect').', <a href="http://www.feedburner.com/">'.__('create your FeedBurner account.', 'fb-redirect').'</a>'; ?></td>
	</tr>
<?php
} else {
?>
	<tr>
		<th width="20%"><?php _e('Active', 'fb-redirect'); ?>:</th>
		<td><select name="fb_active">
			<option value="1"<?php if($active) { echo ' selected="selected"'; } ?>><?php _e('Activate', 'fb-redirect'); ?></option>
			<option value="0"<?php if(!$active) { echo ' selected="selected"'; } ?>><?php _e('Deactivate', 'fb-redirect'); ?></option>
		</select></td>
	</tr>
<?php if ($this->use_permalinks) { ?>
	<tr>
		<th width="20%"><?php _e('Use .htaccess', 'fb-redirect'); ?>:</th>
		<td><select name="fb_htaccess">
			<option value="1"<?php if($htaccess) { echo ' selected="selected"'; } ?>><?php _e('Yes', 'fb-redirect'); ?></option>
			<option value="0"<?php if(!$htaccess) { echo ' selected="selected"'; } ?>><?php _e('No', 'fb-redirect'); ?></option>
		</select> &mdash; <?php _e('Do you want to use .htaccess when redirect? Visitors who redirected by .htaccess cannot be tracked with stats plugin.', 'fb-redirect'); ?></td>
	</tr>
<?php 
	}
}
?>
	</table>
	<p class="submit">
	<input type="submit" class="button" name="fb_update_options" value="<?php _e('Update Options', 'fb-redirect'); ?>" />	
	</p>
	</fieldset>
	</form>
<?php 
if($fb_main && $active) { 
?>
	<hr />
	<form name="fbredirect_current" method="post" action="">
	<fieldset class="options">
	<legend><?php _e('Current Redirections', 'fb-redirect'); ?></legend>
	<table cellspacing="2" cellpadding="5" width="100%">
	<tr class="alternate">
		<th>&nbsp;</th>
		<th><?php _e('Type', 'fb-redirect'); ?></th>
		<th><?php _e('Value', 'fb-redirect'); ?></th>
		<th><?php _e('FeedBurner Path', 'fb-redirect'); ?></th>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td><strong><?php _e('Entire', 'fb-redirect'); ?></strong></td>
		<td><?php _e('Your main feed. (added by default)', 'fb-redirect'); ?></td>
		<td><a href="<?php echo $this->fb_url.$fb_main.'/'; ?>">/<?php echo $fb_main; ?>/</a></td>
	</tr>
<?php
	if (is_array($this->rules) && !empty($this->rules)) {
		$j = 1;
		foreach ($this->rules as $type=>$rules) {
			$i = 0;
			foreach ($rules as $key=>$path) {
				$nice_name = $this->get_nicename($type, $key);
?>
	<tr valign="top"<?php if ($j % 2 != 0) echo ' class="alternate"'; ?>>
		<td><input type="checkbox" name="fb_delete[<?php echo $type; ?>][<?php echo $key; ?>]" value="1" /></td>
		<td><strong><?php echo ucwords($type); ?></strong></td>
		<td><?php echo $nice_name; ?></td>
		<td><a href="<?php echo $this->fb_url.$path.'/'; ?>"><?php echo '/'.$path.'/'; ?></a></td>
	</tr>
<?php
				$i++;$j++;
			}
		}
	}
?>
	</table>
	<p class="submit">
	<input type="submit" class="button" name="delete_checked" value="<?php _e('Delete Checked', 'fb-redirect'); ?>" />
	</p>
	</fieldset>
	</form>
	<hr />

	<form name="fbredirect_add" method="post" action="">
	<fieldset class="options">
	<legend><?php _e('Add New Redirection', 'fb-redirect'); ?></legend>
	<p><strong><?php _e('You should add feedburder url for each rules first.', 'fb-redirect'); ?></strong></p>
	<input type="hidden" name="fb_add_rule" value="1" />
	<table cellspacing="2" cellpadding="5" width="100%">
	<tr class="alternate">
		<th><?php _e('Type', 'fb-redirect'); ?></th>
		<th><?php _e('Value', 'fb-redirect'); ?></th>
		<th><?php _e('FeedBurner Path', 'fb-redirect'); ?></th>
		<th>&nbsp;</th>
	</tr>
<?php 
	if($this->rules === '1' || !isset($this->rules['comments'])) {
?>
	<!-- Comments Feed -->
	<tr>
		<td><strong><?php _e('Comments', 'fb-redirect'); ?></strong></td>
		<td>&nbsp;<input type="hidden" name="fb_add[comments][value]" value="1" /></td>
		<td>/<input type="text" name="fb_add[comments][path]" value="" /></td>
		<td><input type="submit" class="button" name="fb_add_comments" value="<?php _e('Add', 'fb-redirect'); ?>" /></td>
	</tr>
<?php
	}
?>
	<!-- Category Feed -->
	<tr>
		<td><strong><?php _e('Category', 'fb-redirect'); ?></strong></td>
		<td><select name="fb_add[cat][value]">
			<option value="0"><?php _e('Select Category', 'fb-redirect'); ?></option>
<?php
	$cats = $this->get_categories();
	if($cats) {
		foreach($cats as $cat) {
?>
	<option value="<?php echo $cat->ID; ?>"><?php echo $cat->name; ?></option>
<?php 
		}
	}
?>
		</select></td>
		<td>/<input type="text" name="fb_add[cat][path]" value="" /></td>
		<td><input type="submit" class="button" name="fb_add_cat" value="<?php _e('Add', 'fb-redirect'); ?>" /></td>
	</tr>
	<!-- Author Feed -->
	<tr>
		<td><strong><?php _e('Author', 'fb-redirect'); ?></strong></td>
		<td><select name="fb_add[author][value]">
			<option value="0"><?php _e('Select Author', 'fb-redirect'); ?></option>
<?php
	$authors = $this->get_authors();
	if($authors) {
	foreach($authors as $author) {
?>
	<option value="<?php echo $author->ID; ?>"><?php echo $author->name; ?></option>
<?php 
		}
	}
?>
		</select></td>
		<td>/<input type="text" name="fb_add[author][path]" value="" /></td>
		<td><input type="submit" class="button" name="fb_add_author" value="<?php _e('Add', 'fb-redirect'); ?>" /></td>
	</tr>
<?php
	if($this->use_tag()) {
?>
	<!-- Tag Feed -->
	<tr>
		<td><strong><?php _e('Tag', 'fb-redirect'); ?></strong></td>
		<td><select name="fb_add[tag][value]">
			<option value="0"><?php _e('Select Tag', 'fb-redirect'); ?></option>
<?php
		$tags = $this->get_tags();
		if(!empty($tags)) {
			foreach($tags as $tag) {
?>
	<option value="<?php echo $tag; ?>"><?php echo $tag; ?></option>
<?php 
			}
		}
?>
		</select></td>
		<td>/<input type="text" name="fb_add[tag][path]" value="" /></td>
		<td><input type="submit" class="button" name="fb_add_tag" value="<?php _e('Add', 'fb-redirect'); ?>" /></td>
	</tr>
<?php
	}
?>
	</table>
	</fieldset>
	</form>
<?php
}
?>
</div>
<?php 
	}

	function &get_instance() {
		static $instance = array();
		if ( empty( $instance ) ) {
			$instance[] =& new FeedBurner_Redirect();
		}
		return $instance[0];
	}

} // end of class

// Instance of plugin
$FB_Redirect =& FeedBurner_Redirect::get_instance();

// Register Hooks
if(!$FB_Redirect->is_feedburner() && $FB_Redirect->option['active'] && $FB_Redirect->option['fb_main']) {
		add_action('init', array(&$FB_Redirect, 'direct_access'));
		add_action('template_redirect', array(&$FB_Redirect, '_redirect'));
}

add_action('admin_menu', array(&$FB_Redirect, 'add_options_page'));

// Unset
unset($FB_Redirect);

?>